#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <time.h>
#include <dos.h>

#include "mmenu.cpp"

// -- Defines -----------------------
#define BUILD "0027 ALPHA"

#define DEBUG_MODE 0

#define MAX_MAPF_SIZE 255

#define MAX_MAP_XSIZE 300
#define MAX_MAP_YSIZE 300

#define MAX_VIEW_XSIZE 80
#define MAX_VIEW_YSIZE 50

#define MAX_MOVING_ROOMS 10

#define MAX_VIEWS 4

#define MAX_PL 5
#define MAX_PL_LENGTH 30

#define MAX_CONSOLE_LINES 4

#define CHT_BUF_SIZE 127
// ----------------------------------

// Debug mode
int n_debug_mode=DEBUG_MODE;

// Map fields
int n_mapf_size=MAX_MAPF_SIZE;
struct s_mapf {
				unsigned char m; // Map field properties
				unsigned char c; // Char
				unsigned char f,b; // Foreground, background color
			  } mapf[MAX_MAPF_SIZE];

// Game map
int n_map_xsize=MAX_MAP_XSIZE;
int n_map_ysize=MAX_MAP_YSIZE;
struct s_map {
			   char name[64]; // Map name
			   //unsigned char m[MAX_MAP_XSIZE][MAX_MAP_YSIZE]; // Map fields properties
			   unsigned char *m[MAX_MAP_XSIZE];
			 } map;
char m_rooms[MAX_MOVING_ROOMS];

// Player views
int n_views=0; // Number of active player views
int n_view_xsize=MAX_VIEW_XSIZE;
int n_view_ysize=MAX_VIEW_YSIZE;
struct s_views {
				 int xp,yp; // X and Y position on screen
				 int xm,ym; // X and Y position on map
				 int xs,ys; // X and Y size to display
				 unsigned char mv; // Moving (0..249 - pl num., 250 - don't move)
				 //unsigned char tm1[MAX_VIEW_XSIZE][MAX_VIEW_YSIZE];
				 //s_map tm1; // Temporary map (for screen redraw)
				 unsigned char *tm1[MAX_VIEW_XSIZE]; // Temporary map (for screen redraw)
			   } views[MAX_VIEWS];

// Player info
unsigned char n_pl=0; // Number of active players
unsigned char w_flag=255, wl_flag=255; // Who has got flag (0...250 - player, 255 - not yet stolen)
struct s_pl {
			  char name[128]; // Player name
			  unsigned long s; // Player score
			  unsigned char pcolor,pchar[2]; // Player color, Player head character
			  unsigned char d; // Actual player direction (0=nothing, 1=up, 2=down, 3=left, 4=right)
			  unsigned char alen; //,blen; // Actual length, Absolute length(length to be)
			  float blen; // Absolute length(length to be)
			  int x[MAX_PL_LENGTH],y[MAX_PL_LENGTH]; // Player fields
			  unsigned char tel; // Is player in teleport
			  unsigned char xsl,ysl,wsl; // X,Y and widtch of status location (on screen)
			  unsigned char c[6][2]; // Player keyboard controls
			  unsigned char cn; // NK keys status
			} pl[MAX_PL];

// Console
unsigned char n_console_lines=MAX_CONSOLE_LINES;
unsigned char console_redraw=0;
struct s_console {
				   char l[128]; // Console text line
				   unsigned char f,b; // Foreground and background color
				 } console[MAX_CONSOLE_LINES];

unsigned char end_p=0;
unsigned long timer1=0,timer2=0; // Game timer

clock_t game_stime, game_atime, game_latime;
float do_move_time=0.05; // Game speed

char map_file_name[128];

unsigned char chtbuf[CHT_BUF_SIZE];

unsigned char far *scr1=(unsigned char far *)MK_FP(0xb800,0);

void redraw_screen();

// -------------------------------------------------------------------------
void tcolor(int fc, int bc)
{
  textcolor(fc);
  textbackground(bc);
}

// -- String buffer functions - begin --------------------------------------
unsigned char ch_upcase(unsigned char ch1)
{
  char ch2;

  ch2=ch1;
  if ( (ch2>96) && (ch2<123) )
  {
	ch2-=32;
  }

  return ch2;
}

void buf_init(unsigned char *buf1, int buf1_size)
// Initialize the cheat buffer
{
  int i1;

  for (i1=0; i1<buf1_size; i1++)
  {
	buf1[i1]=32;
  }
}

void buf_addchar(unsigned char *buf1, int buf1_size, unsigned char ch1)
// Add character to the cheat buffer
{
  int i1;

  for (i1=1; i1<buf1_size; i1++)
  {
	buf1[(i1-1)]=buf1[i1];
  }

  buf1[(buf1_size-1)]=ch1;
}

/*
char buf_chkcont(unsigned char *buf1, int buf1_size, unsigned char s1[])
// Check content of the cheat buffer
{
  int i1,i2;

  if (strlen(s1)<=buf1_size)
  {
	i2=1;
	for (i1=0; i1<strlen(s1); i1++)
	{
	  if (s1[(strlen(s1)-1-i1)]!=buf1[(buf1_size-1-i1)])
	  {
		i2=0;
	  }
	}

	return i2;
  }
  else
  {
	return 0;
  }
}
*/

char buf_chkcont(unsigned char *buf1, int buf1_size, unsigned char s1[], unsigned char chk_uc)
// Check content of the cheat buffer
{
  int i1,i2;

  if (strlen(s1)<=buf1_size)
  {
	i2=1;
	for (i1=0; i1<strlen(s1); i1++)
	{
		   // Check upper/lower case
	  if ( (chk_uc==0) && (s1[(strlen(s1)-1-i1)]!=buf1[(buf1_size-1-i1)])
		   // Don't check upper/lower case
		|| (chk_uc==1) && (ch_upcase(s1[(strlen(s1)-1-i1)])!=ch_upcase(buf1[(buf1_size-1-i1)])) )
	  {
		i2=0;
	  }
	}

	return i2;
  }
  else
  {
	return 0;
  }
}

void buf_display(unsigned char *buf1, int buf1_size)
// Display content of the cheat buffer
{
  int i1;

  clrscr();
  gotoxy(1,1);
  printf("-");
  for (i1=0; i1<buf1_size; i1++)
  {
	printf("%c", buf1[i1]);
  }
  printf("-\n");
}
// -- String buffer functions - end ----------------------------------------

void redraw_console()
{
  int i1;

  tcolor(8,0);
  gotoxy(1,(50-n_console_lines));
  for (i1=0; i1<80; i1++)
  {
	cprintf("");
  }

  for (i1=0; i1<n_console_lines; i1++)
  {
	gotoxy(1,(50-i1));

	tcolor(7,0);
	clreol();

	if (console[i1].f!=255) { tcolor(console[i1].f, console[i1].b); }
					   else { tcolor(15,0); }

	if (i1>0) { tcolor(8,0); }

	cprintf("%s", console[i1].l);
  }

  console_redraw=0;
}

void write_console(char text1[], unsigned char f)
{
  int i1;

  for (i1=(n_console_lines-1); i1>0; i1--)
  {
	strcpy(console[i1].l, console[(i1-1)].l);
	console[i1].f=console[(i1-1)].f;
	console[i1].b=console[(i1-1)].b;
  }

  strcpy(console[0].l, text1);
  console[0].f=f;
  console[0].b=0;

  console_redraw=1;
}

void init_console()
{
  int i1;

  for (i1=0; i1<MAX_CONSOLE_LINES; i1++)
  {
	strcpy(console[i1].l,"");
	console[i1].f=255;
	console[i1].b=0;
  }

  console_redraw=1;
}
// -------------------------------------------------------------------------
void redraw_basic_screen()
// Draw text and gfx which is not changed during game on the screen
{
  // Clear screen
  tcolor(7,0);
  clrscr();

  // Hide cursor
  tcolor(0,0);
  gotoxy(1,1);
  cprintf(" ");
  tcolor(7,0);
  gotoxy(1,1);
}

int xy_pl_exist(int x1, int y1, int wret)
// Check if there is a player on x1,y1
// 0 - 250 ... player number
//     254 ... last field of player (not showed)
//     255 ... there is no player

// Wret
// 0 ... player num
// 1 ... field num
{
  int i1,i2;

  for (i1=0; i1<n_pl; i1++) // Players 1...n
  {
	for (i2=0; i2<=pl[i1].alen; i2++) // 0...player length
	{
	  if ( (pl[i1].x[i2]==x1) && (pl[i1].y[i2]==y1) )
	  {
		switch (wret)
		{
		  case 0 : if (i2==pl[i1].alen) { return 254; }
								   else { return i1; }
				   break;
		  case 1 : return i2;
				   break;
		}
	  }
	}
  }

  return 255;
}

unsigned char mk_random_bkgchar()
{
  if (random(100)<60) { return (32+random(220)); }
				 else { return (32); }
}

void putcxy(unsigned char ch1, unsigned char x1, unsigned char y1, unsigned char fc, unsigned char bc)
{
  scr1[(y1-1)*80*2+(x1-1)*2]=ch1;
  if (bc<8) { scr1[(y1-1)*80*2+(x1-1)*2+1]=bc*16+fc; }
	   else { scr1[(y1-1)*80*2+(x1-1)*2+1]=(bc-8)*16+fc; }
}

void show_map(int m_num)
// Redraw map on the screen
{
  int ix,iy,i1,i2,i3,i4;
  unsigned char x1,y1,fc1,bc1;
  unsigned char ach; // Arrow character

  // Show map
  for (iy=views[m_num].ym; iy<(views[m_num].ym+views[m_num].ys); iy++)
  for (ix=views[m_num].xm; ix<(views[m_num].xm+views[m_num].xs); ix++)
  {
	if ( (ix<0) || (iy<0) || !(ix<n_map_xsize) || !(iy<n_map_ysize) )
	//   && (views[m_num].tm1.m[(ix-views[m_num].xm)][(iy-views[m_num].ym)]!=254) )
	{
	  if (views[m_num].tm1[(ix-views[m_num].xm)][(iy-views[m_num].ym)]!=254)
	  {
		// Scrolling line between background and map borders
		if (mapf[ views[m_num].tm1[(ix-views[m_num].xm)][(iy-views[m_num].ym)] ].c!='@')
		{
		  putcxy(mk_random_bkgchar(), (views[m_num].xp+ix-views[m_num].xm), (views[m_num].yp+iy-views[m_num].ym), 8, 0);
		  views[m_num].tm1[(ix-views[m_num].xm)][(iy-views[m_num].ym)]=254;
		}
	  }
	}
	else
	{
	  i3=xy_pl_exist(ix,iy,0);
	  // This is for less redrawing - draw only changed things on the screen
	  //if ((views[m_num].tm1.m[(ix-views[m_num].xm)][(iy-views[m_num].ym)]) != (map.m[ix][iy]) && (i3>250))
	  if ( ( (views[m_num].tm1[(ix-views[m_num].xm)][(iy-views[m_num].ym)]) != (map.m[ix][iy])
		  || ((w_flag!=wl_flag) && (mapf[ map.m[ix][iy] ].m==4)) // Flag - capture place
		  || ((w_flag!=wl_flag) && (mapf[ map.m[ix][iy] ].m==5)) // Flag - destination
		   )
		&& (i3>250) )
	  {
		x1=(views[m_num].xp+ix-views[m_num].xm);
		y1=(views[m_num].yp+iy-views[m_num].ym);
		fc1=mapf[ map.m[ix][iy] ].f;
		bc1=mapf[ map.m[ix][iy] ].b;

		// Flag is not yet redrawed immediately

		// Map properties
		// 0 ... free field
		// 1 ... wall
		// 2 ... free field (not yet digged)
		// 3 ... food

		if ( (mapf[ map.m[ix][iy] ].c!='@')
		  && (mapf[ map.m[ix][iy] ].m!=4)
		  && (mapf[ map.m[ix][iy] ].m!=5) )
		{
		  putcxy(mapf[ map.m[ix][iy] ].c, x1, y1, fc1, bc1);
		}
		else
		{
		  if (mapf[ map.m[ix][iy] ].c=='@')
		  {
			// Scrolling line between background and map borders
			if (views[m_num].tm1[(ix-views[m_num].xm)][(iy-views[m_num].ym)]!=254)
			{
			  putcxy(mk_random_bkgchar(), x1, y1, fc1, bc1);
			}
		  }

		  if (mapf[ map.m[ix][iy] ].m==4)
		  {
			if (w_flag==255) putcxy(mapf[ map.m[ix][iy] ].c, x1, y1, fc1, bc1); //cprintf("%c",mapf[ map.m[ix][iy] ].c);
						else putcxy(' ', x1, y1, fc1, bc1); //cprintf(" ");
		  }

		  if (mapf[ map.m[ix][iy] ].m==5)
		  {
			if (w_flag!=255) putcxy(mapf[ map.m[ix][iy] ].c, x1, y1, fc1, bc1); //cprintf("%c",mapf[ map.m[ix][iy] ].c);
						else putcxy(' ', x1, y1, fc1, bc1); //cprintf(" ");
		  }
		}

		// Write new map properties to the temporary map screen
		views[m_num].tm1[(ix-views[m_num].xm)][(iy-views[m_num].ym)]=map.m[ix][iy];
	  }

	  if (i3!=255) // && (i3!=254) )
	  {
		views[m_num].tm1[(ix-views[m_num].xm)][(iy-views[m_num].ym)]=255;
	  }
	}
  }

  // Show players
  for (i1=0; i1<n_pl; i1++) // Players 1...n
  {
	for (i2=0; i2<pl[i1].alen; i2++) // 0...player length
	{
	  ix=pl[i1].x[i2]-views[m_num].xm;
	  iy=pl[i1].y[i2]-views[m_num].ym;

	  // If player is in view, show it
	  if ( (ix>=0) && (iy>=0) && (ix<views[m_num].xs) && (iy<views[m_num].ys) )
	  {
		ix+=views[m_num].xp;
		iy+=views[m_num].yp;

		switch (i2)
		{
		   case 0 : if (w_flag==i1) { putcxy('', ix, iy, pl[i1].pcolor, mapf[ map.m[ pl[i1].x[i2] ][ pl[i1].y[i2] ] ].b); }
							   else { putcxy(pl[i1].pchar[0], ix, iy, pl[i1].pcolor, mapf[ map.m[ pl[i1].x[i2] ][ pl[i1].y[i2] ] ].b); }
					break;
		  default : putcxy(pl[i1].pchar[1], ix, iy, pl[i1].pcolor, mapf[ map.m[ pl[i1].x[i2] ][ pl[i1].y[i2] ] ].b); break;
		}
	  }
	  else // If player is not in view, show arrow
	  {
		if ( (i2==0) && (n_debug_mode==1) ) // Show only players first character (head) position
		{
		  i3=0;
		  i4=0;

		  if (ix>=0)
		  {
			if (ix<views[m_num].xs) { i3=ix; }
							   else { i3=views[m_num].xs-1; }
		  } // if - ix

		  if (iy>=0)
		  {
			if (iy<views[m_num].ys) { i4=iy; }
							   else { i4=views[m_num].ys-1; }
		  } // if - iy

		  ach=232; // 232 233 234 235 || 236 237 238 239

		  if (i3==0)                   { ach=234; }
		  if (i3==(views[m_num].xs-1)) { ach=235; }
		  if (i4==0)                   { ach=232; }
		  if (i4==(views[m_num].ys-1)) { ach=233; }

		  if ( (i4==0) && (i3==0) )                                     { ach=236; }
		  if ( (i4==0) && (i3==(views[m_num].xs-1)) )                   { ach=237; }
		  if ( (i4==(views[m_num].ys-1)) && (i3==0) )                   { ach=238; }
		  if ( (i4==(views[m_num].ys-1)) && (i3==(views[m_num].xs-1)) ) { ach=239; }

		  /*
		  if ( (i3>0) && (pl[i1].d==2) )                   { views[m_num].tm1[(i3-1)][i4]=255; }
		  if ( (i3<(views[m_num].xs-1)) && (pl[i1].d==1) ) { views[m_num].tm1[(i3+1)][i4]=255; }
		  if ( (i4>0) && (pl[i1].d==4) )                   { views[m_num].tm1[i3][(i4-1)]=255; }
		  if ( (i4<(views[m_num].ys-1)) && (pl[i1].d==3) ) { views[m_num].tm1[i3][(i4+1)]=255; }
		  */
		  views[m_num].tm1[i3][i4]=255;

		  /*
		  i5=i3+views[m_num].xm; // X position on the map
		  i6=i4+views[m_num].ym; // Y position on the map
		  */

		  i3+=views[m_num].xp; // X position on the screen
		  i4+=views[m_num].yp; // Y position on the screen

		  putcxy(ach, i3, i4, pl[i1].pcolor, 0);
		} // if - i2
	  } // if - player is in view
	} // for - i2
  } // for - i1

  gotoxy (1,1);
}

void show_pl_stat(int pln)
// Show one line players statistics
{
  char s1[128],s2[128];
  int i1,i2;

  // Name
  strcpy(s1, "  [ ");
  strcat(s1, pl[pln].name);

  // Score
  strcat(s1, " ] S=");
  itoa(pl[pln].s, s2, 10);
  strcat(s1, s2);

  // Flag
  if (w_flag==pln) strcat(s1, " (F) L=");
			  else strcat(s1, " (-) L=");

  // Actual length
  itoa(pl[pln].alen, s2, 10);
  strcat(s1, s2);

  for (i1=0; i1<strlen(s1); i1++)
  {
	putcxy(s1[i1], (pl[pln].xsl+i1), pl[pln].ysl, 15, pl[pln].pcolor);
  }

  for (i1=strlen(s1); i1<pl[pln].wsl; i1++)
  {
	putcxy(' ', (pl[pln].xsl+i1), pl[pln].ysl, 15, pl[pln].pcolor);
  }
}

void change_numofpl(int numofpl)
// This function will change number of active players in game
{
  int i1,i2,i3;

  switch (numofpl)
  {
	// 1 player
	case 1 : n_views=1;

			 views[0].xp=1;   views[0].yp=3;
			 views[0].xm=0;   views[0].ym=0;
			 views[0].xs=80;  views[0].ys=43;
			 views[0].mv=0;

			 n_pl=1;
			 pl[0].xsl=1; pl[0].ysl=2; pl[0].wsl=80;

			 write_console("Switched to one player mode.", 255);
			 break;

	// 2 players
	case 2 : n_views=2;

			 views[0].xp=1;   views[0].yp=3;
			 views[0].xm=0;   views[0].ym=0;
			 views[0].xs=39;  views[0].ys=43;
			 views[0].mv=0;

			 views[1].xp=42;  views[1].yp=3;
			 views[1].xm=0;   views[1].ym=0;
			 views[1].xs=39;  views[1].ys=43;
			 views[1].mv=1;

			 n_pl=2;
			 pl[0].xsl=1; pl[0].ysl=2; pl[0].wsl=39;
			 pl[1].xsl=42; pl[1].ysl=2; pl[1].wsl=39;

			 write_console("Switched to two players mode.", 255);
			 break;
	// 3 players
	case 3 : n_views=3;

			 views[0].xp=1;   views[0].yp=3;
			 views[0].xm=0;   views[0].ym=0;
			 views[0].xs=43;  views[0].ys=20;
			 views[0].mv=0;

			 views[1].xp=1;   views[1].yp=26;
			 views[1].xm=0;   views[1].ym=0;
			 views[1].xs=43;  views[1].ys=20;
			 views[1].mv=1;

			 views[2].xp=46;  views[2].yp=3;
			 views[2].xm=0;   views[2].ym=0;
			 views[2].xs=35;  views[2].ys=43;
			 views[2].mv=2;

			 n_pl=3;
			 pl[0].xsl=1;  pl[0].ysl=2; pl[0].wsl=43;
			 pl[1].xsl=1;  pl[1].ysl=25; pl[1].wsl=43;
			 pl[2].xsl=46; pl[2].ysl=2; pl[2].wsl=35;

			 write_console("Switched to three players mode.", 255);
			 break;
	// 4 players
	case 4 : n_views=4;

			 views[0].xp=1;   views[0].yp=3;
			 views[0].xm=0;   views[0].ym=0;
			 views[0].xs=39;  views[0].ys=20;
			 views[0].mv=0;

			 views[1].xp=1;   views[1].yp=26;
			 views[1].xm=0;   views[1].ym=0;
			 views[1].xs=39;  views[1].ys=20;
			 views[1].mv=1;

			 views[2].xp=42;  views[2].yp=3;
			 views[2].xm=0;   views[2].ym=0;
			 views[2].xs=39;  views[2].ys=20;
			 views[2].mv=2;

			 views[3].xp=42;  views[3].yp=26;
			 views[3].xm=0;   views[3].ym=0;
			 views[3].xs=39;  views[3].ys=20;
			 views[3].mv=3;

			 n_pl=4;
			 pl[0].xsl=1;  pl[0].ysl=2; pl[0].wsl=39;
			 pl[1].xsl=1;  pl[1].ysl=25; pl[1].wsl=39;
			 pl[2].xsl=42; pl[2].ysl=2; pl[2].wsl=39;
			 pl[3].xsl=42; pl[3].ysl=25; pl[3].wsl=39;

			 write_console("Switched to four players mode.", 255);
			 break;
  }

  for (i3=0; i3<n_pl; i3++)
  {
	for (i2=0; i2<MAX_VIEW_YSIZE; i2++)
	for (i1=0; i1<MAX_VIEW_XSIZE; i1++)
	{
	  views[i3].tm1[i1][i2]=255;
	}
  }

  console_redraw=1;
  redraw_basic_screen();
}

void bonus_map1()
// Bonus MAP1
{
  int ix,iy;

  mapf[0].m= 0; mapf[0].f= 1; mapf[0].b= 1; mapf[0].c=' ';
  mapf[1].m= 1; mapf[1].f=14; mapf[1].b=14; mapf[1].c='';
  mapf[2].m= 2; mapf[2].f= 9; mapf[2].b= 1; mapf[2].c='';
  mapf[3].m= 3; mapf[3].f=10; mapf[3].b= 1; mapf[3].c='O';
  mapf[4].m= 1; mapf[4].f= 8; mapf[4].b= 0; mapf[4].c='@';

  // CTF
  mapf[5].m= 4; mapf[5].f=10; mapf[5].b= 7; mapf[5].c='';
  mapf[6].m= 5; mapf[6].f= 9; mapf[6].b= 7; mapf[6].c='';

  // Other objects
  mapf[7].m= 0; mapf[7].f= 7; mapf[7].b= 0; mapf[7].c='x';
  mapf[8].m= 0; mapf[8].f= 7; mapf[8].b= 0; mapf[8].c='x';
  mapf[9].m= 0; mapf[9].f= 7; mapf[9].b= 0; mapf[9].c='x';

  n_mapf_size=10;

  // Map name
  strcpy(map.name,"Bonus MAP1");

  // Initialise map fields
  for (iy=0; iy<n_map_ysize; iy++)
  for (ix=0; ix<n_map_xsize; ix++)
  {
	map.m[ix][iy]=0; // Clear all map fields

	// Create map borders
	if ( (ix==0) || (iy==0) || (ix==(n_map_xsize-1)) || (iy==(n_map_ysize-1)) )
	  {  map.m[ix][iy]=1;  }
  }

  // Digging fields
  for (iy=1; iy<((n_map_ysize / 2)+1); iy++)
  for (ix=(n_map_xsize-(n_map_xsize / 2)); ix<(n_map_xsize-1); ix++)
  {
	map.m[ix][iy]=2;
  }

  // Eating fields
  for (iy=((n_map_ysize / 2)+2); iy<(n_map_ysize-1); iy++)
  for (ix=((n_map_xsize / 2)+2); ix<(n_map_xsize-1); ix++)
  {
	if (random(100)<5)
	  {  map.m[ix][iy]=3;  }
  }

  // Cross in center
  for (ix=(n_map_xsize / 5); ix<((n_map_xsize / 5)*2-4); ix++)
  {
	map.m[ix][(n_map_ysize / 2)]=1;
	map.m[(ix+((n_map_xsize / 5)*2)+4)][(n_map_ysize / 2)]=1;
  }

  for (iy=(n_map_ysize / 5); iy<((n_map_ysize / 5)*2-4); iy++)
  {
	map.m[(n_map_xsize / 2)][iy]=1;
	map.m[(n_map_xsize / 2)][(iy+((n_map_ysize / 5)*2)+4)]=1;
  }

  // Rectangle in center
  for (iy=((n_map_ysize / 5)*2); iy<((n_map_ysize / 5)*3); iy++)
  for (ix=((n_map_xsize / 5)*2); ix<((n_map_xsize / 5)*3); ix++)
  {
	if ( (ix==((n_map_xsize / 5)*2)) || (iy==((n_map_ysize / 5)*2))
	  || (ix==((n_map_xsize / 5)*3)-1) || (iy==((n_map_ysize / 5)*3)-1) )
	{
	  map.m[ix][iy]=1;
	}
	else
	{
	  map.m[ix][iy]=4;
	}
  }
}

void load_map(char map_file[])
{
  int i1,i2,ix,iy;
  unsigned char chx;
  FILE *in;

  if (n_debug_mode==1)
  {
	printf("\n");
	printf("Map file name: %s\n", map_file);
  }

  if ((in = fopen(map_file, "rb")) == NULL)
  {
	 printf("Cannot open %s for reading.\n", map_file);
  }
  else
  {
	// --- Header ----------------------------------------------------------
	if (n_debug_mode==1) { printf("Map ID: "); }
	for (i1=0; i1<5; i1++)
	{
	  chx=fgetc(in);
	  if (n_debug_mode==1) { printf("%c", chx); }
	}
	if (n_debug_mode==1) { printf("\n"); }
	// ---------------------------------------------------------------------

	// --- Map name --------------------------------------------------------
	strcpy(map.name, "");
	for (i1=0; i1<32; i1++)
	{
	  chx=fgetc(in);
	  map.name[i1]=chx;
	}
	map.name[32]=0;
	if (n_debug_mode==1) { printf("Map name: %s\n", map.name); }
	// ---------------------------------------------------------------------

	// --- Mapf size -------------------------------------------------------
	n_mapf_size=fgetc(in); // MAPF_SIZE
	if (n_debug_mode==1) { printf("mapf_size: %i\n", n_mapf_size); }
	// ---------------------------------------------------------------------

	// --- Map size --------------------------------------------------------
	n_map_xsize=fgetc(in); // X_SIZE
	n_map_ysize=fgetc(in); // Y_SIZE

	if (n_debug_mode==1)
	{
	  printf("x_size / max_x_size: %i / %i\n", n_map_xsize, MAX_MAP_XSIZE);
	  printf("y_size / max_y_size: %i / %i\n", n_map_ysize, MAX_MAP_YSIZE);
	}
	// ---------------------------------------------------------------------

	// --- Allocate memory for map -----------------------------------------
	if (n_debug_mode==1) { printf("allocating memory (%u bytes) [", (n_map_xsize*n_map_ysize)); }
	for (i1=0; i1<n_map_xsize; i1++)
	{
	  if ( (map.m[i1]=(unsigned char*)malloc(n_map_ysize)) == NULL)
	  {
		printf("Error allocating memory.\n");
		exit(1);
	  }
	  else
	  {
		if (n_debug_mode==1) { printf("."); }
	  }
	}
	if (n_debug_mode==1)
	{
	  printf("]\n");
	  printf("OK, memory successfully allocated.\n");
	}
	// ---------------------------------------------------------------------

	// --- Players ---------------------------------------------------------
	i2=fgetc(in); // Number of players
	for (i1=0; i1<i2; i1++)
	{
	  pl[i1].x[0]=fgetc(in);
	  pl[i1].y[0]=fgetc(in);
	  pl[i1].x[1]=pl[i1].x[0];
	  pl[i1].y[1]=pl[i1].y[0];
	}
	if (n_debug_mode==1) { printf("Players: %i\n", i2); }
	// ---------------------------------------------------------------------

	// --- Mapf ------------------------------------------------------------
	for (i1=0; i1<n_mapf_size; i1++)
	{
	  mapf[i1].m=fgetc(in);
	  mapf[i1].c=fgetc(in);
	  mapf[i1].f=fgetc(in);
	  mapf[i1].b=fgetc(in);
	}
	// ---------------------------------------------------------------------

	// --- Load map --------------------------------------------------------
	if ( (n_map_xsize<=MAX_MAP_XSIZE) && (n_map_ysize<=MAX_MAP_YSIZE) )
	{
	  for (iy=0; iy<n_map_ysize; iy++)
	  for (ix=0; ix<n_map_xsize; ix++)
	  {
		map.m[ix][iy]=fgetc(in);
	  }

	  for (i1=0; i1<MAX_MOVING_ROOMS; i1++)
	  {
		m_rooms[i1]=1;
	  }

	  w_flag=255;

	  if (n_debug_mode==1) { printf("OK, map successfully loaded.\n"); }
	}
	else
	{
	  printf("Map size is out of range.\n");
	  exit(1);
	}
	// ---------------------------------------------------------------------

	fclose(in);
  }

  if (n_debug_mode==1)
  {
	printf("\n");
	printf("Press any key...");
	getch();
  }
}

void free_map()
{
  int i1;

  for (i1=0; i1<n_map_xsize; i1++)
  {
	free(map.m[i1]);
  }
}

void init_pl()
// Initialise testing players
{
  n_pl=1;

  // Player1
  strcpy(pl[0].name,"Player1");
  pl[0].s=0;
  pl[0].pcolor=11;
  pl[0].pchar[0]=''; pl[0].pchar[1]='';
  pl[0].d=0;
  pl[0].tel=0;
  pl[0].alen=1; pl[0].blen=5.0;
  pl[0].c[0][0]=0; pl[0].c[0][1]=72; // Up arrow
  pl[0].c[1][0]=0; pl[0].c[1][1]=80; // Down arrow
  pl[0].c[2][0]=0; pl[0].c[2][1]=75; // Left arrow
  pl[0].c[3][0]=0; pl[0].c[3][1]=77; // Right arrow
  //pl[0].x[0]=5; pl[0].y[0]=5;

  // Player2
  strcpy(pl[1].name,"Player2");
  pl[1].s=0;
  pl[1].pcolor=10;
  pl[1].pchar[0]=''; pl[1].pchar[1]='';
  pl[1].d=0;
  pl[1].tel=0;
  pl[1].alen=1; pl[1].blen=5.0;

  pl[1].c[0][0]='w'; pl[1].c[0][1]=0; // Up arrow
  pl[1].c[1][0]='s'; pl[1].c[1][1]=0; // Down arrow
  pl[1].c[2][0]='a'; pl[1].c[2][1]=0; // Left arrow
  pl[1].c[3][0]='d'; pl[1].c[3][1]=0; // Right arrow
  //pl[1].x[0]=n_map_xsize-7; pl[1].y[0]=n_map_ysize-7;

  // Player3
  strcpy(pl[2].name,"Player3");
  pl[2].s=0;
  pl[2].pcolor=12;
  pl[2].pchar[0]=''; pl[2].pchar[1]='';
  pl[2].d=0;
  pl[2].tel=0;
  pl[2].alen=1; pl[2].blen=5.0;

  pl[2].c[0][0]='8'; pl[2].c[0][1]=0; // Up arrow
  pl[2].c[1][0]='2'; pl[2].c[1][1]=0; // Down arrow
  pl[2].c[2][0]='4'; pl[2].c[2][1]=0; // Left arrow
  pl[2].c[3][0]='6'; pl[2].c[3][1]=0; // Right arrow
  //pl[2].x[0]=n_map_xsize-7; pl[2].y[0]=5;

  // Player4
  strcpy(pl[3].name,"Player4");
  pl[3].s=0;
  pl[3].pcolor=13;
  pl[3].pchar[0]=''; pl[3].pchar[1]='';
  pl[3].d=0;
  pl[3].tel=0;
  pl[3].alen=1; pl[3].blen=5.0;

  pl[3].c[0][0]='i'; pl[3].c[0][1]=0; // Up arrow
  pl[3].c[1][0]='k'; pl[3].c[1][1]=0; // Down arrow
  pl[3].c[2][0]='j'; pl[3].c[2][1]=0; // Left arrow
  pl[3].c[3][0]='l'; pl[3].c[3][1]=0; // Right arrow
  //pl[2].x[0]=n_map_xsize-7; pl[2].y[0]=5;
}

void init_views()
// Initialise views
{
  int i1,i2;

  for (i2=0; i2<4; i2++)
  {
	if (n_debug_mode==1) { printf("Init view %i [", i2); }

	for (i1=0; i1<n_view_xsize; i1++)
	{
	  if ( (views[i2].tm1[i1]=(unsigned char*)malloc(n_view_ysize)) == NULL)
	  {
		printf("Error allocating memory.\n");
		exit(1);
	  }
	  else
	  {
		if (n_debug_mode==1) { printf("."); }
	  }
	}

	if (n_debug_mode==1) { printf("]\n"); }
  }

  if (n_debug_mode==1)
  {
	printf("\n");
	printf("Press any key...");
	getch();
  }
}

void free_views()
// Initialise views
{
  int i1,i2;

  //tcolor(7,0);
  //clrscr();
  for (i2=0; i2<4; i2++)
  {

	for (i1=0; i1<n_view_xsize; i1++)
	{
	  free(views[i2].tm1[i1]);
	  //printf(".");
	}

	//printf("x");
  }
  //getch();
}

// -------------------------------------------------------------------------

void switch_var(unsigned char * a1, unsigned char * a2)
{
  int i1;

  i1=*a1;
  *a1=*a2;
  *a2=i1;
}

void rotate_line(int line_n)
{
  int i1;
  unsigned char i2;

  i2=map.m[line_n][line_n];
  for (i1=(line_n+1); i1<(n_map_ysize-line_n); i1++) { switch_var(&map.m[line_n][i1], &i2); }
  for (i1=(line_n+1); i1<(n_map_xsize-line_n); i1++) { switch_var(&map.m[i1][(n_map_ysize-1-line_n)], &i2); }
  for (i1=(n_map_ysize-2-line_n); i1>=line_n; i1--) { switch_var(&map.m[(n_map_xsize-1-line_n)][i1], &i2); }
  for (i1=(n_map_xsize-2-line_n); i1>=line_n; i1--) { switch_var(&map.m[i1][line_n], &i2); }
}

void rotate_map()
{
  int i1,i2,i3,i4;

  // Rotate map
  for (i1=0; i1<(n_map_ysize/2); i1++)
  {
	for (i2=0; i2<(n_map_ysize-1-(2*i1)); i2++)
	{
	  rotate_line(i1);
	}
	redraw_screen();
  }

  // Triangle rotation (doesn't work)
  /*
  for (i2=0; i2<(n_map_ysize); i2++)
  {
	for (i1=i2; i1<(n_map_xsize); i1++)
	{
	  switch_var(&map.m[i1][i2], &map.m[i2][n_map_ysize-i1-1]);
	}
  }
  */

  // Rotate players positions and moving directions
  for (i1=0; i1<n_pl; i1++)
  {
	for (i2=0; i2<pl[i1].alen; i2++)
	{
	  i3=pl[i1].x[i2];
	  i4=pl[i1].y[i2];

	  pl[i1].x[i2]=i4;
	  pl[i1].y[i2]=n_map_ysize-i3-1;
	}

	switch (pl[i1].d)
	{
	  case 1 : pl[i1].d=3; break;
	  case 2 : pl[i1].d=4; break;
	  case 3 : pl[i1].d=2; break;
	  case 4 : pl[i1].d=1; break;
	}
  }
}

// -------------------------------------------------------------------------

void get_keyb()
// This function handle everything about keyboard
{
  int i1;
  char ch;

  if (kbhit())
  {
	ch=getch();
	buf_addchar(chtbuf, CHT_BUF_SIZE, ch);

	// Players controls
	for (i1=0; i1<n_pl; i1++)
	{
	  if (pl[i1].cn==0)
	  {
		// Normal controls
		if ( (pl[i1].c[0][0]==ch) && (pl[i1].c[0][1]==0) ) { if (pl[i1].d!=2) pl[i1].d=1; }
		if ( (pl[i1].c[1][0]==ch) && (pl[i1].c[1][1]==0) ) { if (pl[i1].d!=1) pl[i1].d=2; }
		if ( (pl[i1].c[2][0]==ch) && (pl[i1].c[2][1]==0) ) { if (pl[i1].d!=4) pl[i1].d=3; }
		if ( (pl[i1].c[3][0]==ch) && (pl[i1].c[3][1]==0) ) { if (pl[i1].d!=3) pl[i1].d=4; }
	  } // If - pl[i1].cn

	  if (pl[i1].cn==1)
	  {
		// Nokia keys
		if ( (pl[i1].c[4][0]==ch) && (pl[i1].c[4][1]==0) )
		{
		  switch (pl[i1].d)
		  {
			case 0 : pl[i1].d=3; break;
			case 1 : pl[i1].d=3; break;
			case 2 : pl[i1].d=4; break;
			case 3 : pl[i1].d=2; break;
			case 4 : pl[i1].d=1; break;
		  } // Switch - pl[i1].d
		} // If - rotate left

		if ( (pl[i1].c[5][0]==ch) && (pl[i1].c[5][1]==0) )
		{
		  switch (pl[i1].d)
		  {
			case 0 : pl[i1].d=4; break;
			case 1 : pl[i1].d=4; break;
			case 2 : pl[i1].d=3; break;
			case 3 : pl[i1].d=1; break;
			case 4 : pl[i1].d=2; break;
		  } // Switch - pl[i1].d
		} // If - rotate right
	  } // If - pl[i1].cn
	}

	if (n_debug_mode==1)
	{
	  switch (ch)
	  {
		// Player 1 changes and debug
		case 'x' : pl[0].d=0; break; // Pause player pl[0]
		case 'c' : pl[0].blen++; break; // Add length to pl[0]
		case 'z' : pl[0].blen--; break; // Remove length from pl[0]
		case 'r' : game_stime=clock();
				   game_atime=clock();
				   game_latime=clock()-(do_move_time / CLK_TCK)-1;
				   timer1=0;
				   timer2=0;
				   break;
		case 't' : write_console("test1234", 255);
				   break;
		case 'y' : rotate_map();
				   break;
	  } // switch (ch)
	} // if - n_debug_mode

	switch (ch)
	{
	  case 27 : end_p=1; break; // ESC

	 case '`' : if (n_debug_mode==0) { n_debug_mode=1; }
								else { n_debug_mode=0; }
				break;

	   case 0 : ch=getch();
				buf_addchar(chtbuf, CHT_BUF_SIZE, ch);

				// Players controls
				for (i1=0; i1<n_pl; i1++)
				{
				  if (pl[i1].cn==0)
				  {
					// Normal controls
					if ( (pl[i1].c[0][0]==0) && (pl[i1].c[0][1]==ch) ) { if (pl[i1].d!=2) pl[i1].d=1; }
					if ( (pl[i1].c[1][0]==0) && (pl[i1].c[1][1]==ch) ) { if (pl[i1].d!=1) pl[i1].d=2; }
					if ( (pl[i1].c[2][0]==0) && (pl[i1].c[2][1]==ch) ) { if (pl[i1].d!=4) pl[i1].d=3; }
					if ( (pl[i1].c[3][0]==0) && (pl[i1].c[3][1]==ch) ) { if (pl[i1].d!=3) pl[i1].d=4; }
				  } // If - pl[i1].cn

				  if (pl[i1].cn==1)
				  {
					// Nokia keys
					if ( (pl[i1].c[4][0]==0) && (pl[i1].c[4][1]==ch) )
					{
					  switch (pl[i1].d)
					  {
						case 0 : pl[i1].d=3; break;
						case 1 : pl[i1].d=3; break;
						case 2 : pl[i1].d=4; break;
						case 3 : pl[i1].d=2; break;
						case 4 : pl[i1].d=1; break;
					  } // Switch - pl[i1].d
					} // If - rotate left

					if ( (pl[i1].c[5][0]==0) && (pl[i1].c[5][1]==ch) )
					{
					  switch (pl[i1].d)
					  {
						case 0 : pl[i1].d=4; break;
						case 1 : pl[i1].d=4; break;
						case 2 : pl[i1].d=3; break;
						case 3 : pl[i1].d=1; break;
						case 4 : pl[i1].d=2; break;
					  } // Switch - pl[i1].d
					} // If - rotate right
				  } // If - pl[i1].cn
				}

				if (n_debug_mode==1)
				{
				  switch (ch)
				  {
					case 82 : change_numofpl(2); break; // INS
					case 83 : change_numofpl(1); break; // DEL
					case 71 : change_numofpl(3); break; // HOME
					case 79 : change_numofpl(4); break; // END
				  } // switch (ch)
				} // if - n_debug_mode
				ch=0;
				break;
	}
  }
}

void redraw_screen()
{
  int i1;

  for (i1=0; i1<n_views; i1++)
  {
	show_map(i1);
  }

  for (i1=0; i1<n_pl; i1++)
  {
	show_pl_stat(i1);
  }

  wl_flag=w_flag;
}

int search_for_obj(unsigned char mobj, int * x1, int * y1)
{
  int ix,iy;

  for (iy=0; iy<n_map_ysize; iy++)
  for (ix=0; ix<n_map_xsize; ix++)
  {
	if (mapf[ map.m[ix][iy]].m==mobj)
	{
	  *x1=ix;
	  *y1=iy;
	  return 0;
	}
  }

  return (-1);
}

void move_room(int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int mdir)
{
  int i1,i2,i3;

  switch (mdir)
  {
	// Move left
	case 0 : for (i2=y1; i2<(y2+1); i2++)
			 {
			   i3=map.m[(x3+1)][i2];
			   for (i1=(x3+1); i1<(x4-1); i1++)
			   {
				 map.m[i1][i2]=map.m[i1+1][i2];
			   }
			   map.m[(x4-1)][i2]=i3;
			 }
			 break;

	// Move right
	case 1 : for (i2=y1; i2<(y2+1); i2++)
			 {
			   i3=map.m[(x4-1)][i2];
			   for (i1=(x4-1); i1>(x3+1); i1--)
			   {
				 map.m[i1][i2]=map.m[i1-1][i2];
			   }
			   map.m[(x3+1)][i2]=i3;
			 }
			 break;

	// Move up
	case 2 : for (i2=x1; i2<(x2+1); i2++)
			 {
			   i3=map.m[i2][(y3+1)];
			   for (i1=(y3+1); i1<(y4-1); i1++)
			   {
				 map.m[i2][i1]=map.m[i2][i1+1];
			   }
			   map.m[i2][(y4-1)]=i3;
			 }
			 break;

	// Move down
	case 3 : for (i2=x1; i2<(x2+1); i2++)
			 {
			   i3=map.m[i2][(y4-1)];
			   for (i1=(y4-1); i1>(y3+1); i1--)
			   {
				 map.m[i2][i1]=map.m[i2][i1-1];
			   }
			   map.m[i2][(y3+1)]=i3;
			 }
			 break;
  }
}

int obj_ent(unsigned char objnum)
{
  int retnum=0;

  switch (objnum)
  {
	case 1 : retnum=1;
  }

  if ( (objnum>29) && (objnum<50) )
  {
	retnum=1;
  }

  return retnum;
}

void do_game()
{
  int i1,i2,i3,i4,i5,i6,i7,c_move,new_x,new_y,move_pl;
  int i10,i11,i12,i13,i14,i15,i16,i17; // Must be signed int
  char s1[128];

  for (i1=0; i1<n_pl; i1++) // Players 1...n
  {
	new_x=pl[i1].x[0];
	new_y=pl[i1].y[0];

	c_move=1;
	switch (pl[i1].d)
	{
	   // Up
	   case 1 : if ( (obj_ent(mapf[ map.m[ pl[i1].x[0] ][ (pl[i1].y[0]-1) ]].m)!=0)
				  || (pl[i1].y[0]<=0) ) // || (xy_pl_exist(pl[i1].x[0],(pl[i1].y[0]-1),0)<250) )
				  { c_move=0; }
				new_x=pl[i1].x[0];
				new_y=pl[i1].y[0]-1;
				break;

	   // Down
	   case 2 : if ( (obj_ent(mapf[ map.m[ pl[i1].x[0] ][ (pl[i1].y[0]+1) ]].m)!=0)
				  || (pl[i1].y[0]>=(n_map_ysize-1)) ) //|| (xy_pl_exist(pl[i1].x[0],(pl[i1].y[0]+1),0)<250) )
				  { c_move=0; }
				new_x=pl[i1].x[0];
				new_y=pl[i1].y[0]+1;
				break;

	   // Left
	   case 3 : if ( (obj_ent(mapf[ map.m[ (pl[i1].x[0]-1) ][ pl[i1].y[0] ]].m)!=0)
				  || (pl[i1].x[0]<=0) ) // || (xy_pl_exist((pl[i1].x[0]-1),pl[i1].y[0],0)<250) )
				  { c_move=0; }
				new_x=pl[i1].x[0]-1;
				new_y=pl[i1].y[0];
				break;

	   // Right
	   case 4 : if ( (obj_ent(mapf[ map.m[ (pl[i1].x[0]+1) ][ pl[i1].y[0] ]].m)!=0)
				  || (pl[i1].x[0]>=(n_map_xsize-1)) ) // || (xy_pl_exist((pl[i1].x[0]+1),pl[i1].y[0],0)<250) )
				  { c_move=0; }
				new_x=pl[i1].x[0]+1;
				new_y=pl[i1].y[0];
				break;

	  // Unknown direction ... it will be better if we will not move ;-)
	  default : c_move=0; break;
	}

	// Add or remove length
	if ( (pl[i1].alen<int(pl[i1].blen)) && (c_move==1) ) pl[i1].alen++;
	if (pl[i1].alen>int(pl[i1].blen)) pl[i1].alen--;

	if (pl[i1].alen<1) { pl[i1].alen=1; pl[i1].blen=1.0; }
	if (pl[i1].alen>(MAX_PL_LENGTH-2)) { pl[i1].alen=(MAX_PL_LENGTH-2); pl[i1].blen=(float(MAX_PL_LENGTH)-2.0); }

	// Change other worm prop.
	i2=xy_pl_exist(new_x,new_y,0); // Player number
	i3=xy_pl_exist(new_x,new_y,1); // Player filed num
	if ( (i2<250) && (i2!=i1) )
	{
	  i5=(pl[i2].alen-i3);
	  if ( !((pl[i1].alen+i5)<(MAX_PL_LENGTH-1)) )
		{ i5=MAX_PL_LENGTH-pl[i1].alen-2; }
	  for (i4=0; i4<i5; i4++)
	  {
		pl[i1].x[ (pl[i1].alen+i4) ]=pl[i2].x[(i3+i4)];
		pl[i1].y[ (pl[i1].alen+i4) ]=pl[i2].y[(i3+i4)];
	  }
	  pl[i1].blen=(pl[i1].alen+i5);
	  pl[i1].alen=(pl[i1].alen+i5);

	  pl[i2].alen=i3;
	  pl[i2].blen=i3;

	  if (w_flag==i1)
	  {
		w_flag=i2;
		if (pl[i1].s>19) { pl[i1].s-=20; }
					else { pl[i1].s=0; }
		pl[i2].s+=20;

		// Console message
		strcpy(s1, pl[i2].name);
		strcat(s1, " received the flag from ");
		strcat(s1, pl[i1].name);
		strcat(s1, ".");
		write_console(s1, pl[i2].pcolor);
	  }
	}

	// If move is possible, worm will move to the new position
	if (c_move==1)
	{
	  // Finally, we move the worm
	  for (i2=pl[i1].alen; i2>0; i2--)
	  {
		pl[i1].x[i2]=pl[i1].x[(i2-1)];
		pl[i1].y[i2]=pl[i1].y[(i2-1)];
	  }
	  pl[i1].x[0]=new_x;
	  pl[i1].y[0]=new_y;
	}
	else
	{
	  // If player is not moving - it will lost the flag
	  if (w_flag==i1)
	  {
		w_flag=255;
		if (pl[i1].s>9) { pl[i1].s-=10; }
				   else { pl[i1].s=0; }

		// Console message
		strcpy(s1, pl[i1].name);
		strcat(s1, " lost the flag.");
		write_console(s1, pl[i1].pcolor);
	  }
	}

	// Changing length with properties of map field
	switch (mapf[ map.m[ (pl[i1].x[0]) ][ pl[i1].y[0] ] ].m)
	{
	  //case 0 : pl[i1].blen=pl[i1].blen-0.01; break;
	  case 2 : pl[i1].blen+=0.1; break;
	  case 3 : pl[i1].blen++; break;
	}

	// Player captured the flag
	if ( (mapf[ map.m[ (pl[i1].x[0]) ][ pl[i1].y[0] ] ].m==4) && (w_flag==255) )
	{
	  w_flag=i1;

	  // Console message
	  strcpy(s1, pl[i1].name);
	  strcat(s1, " captured the flag.");
	  write_console(s1, pl[i1].pcolor);
	}

	// Flag arrived to destination
	if ( (mapf[ map.m[ (pl[i1].x[0]) ][ pl[i1].y[0] ] ].m==5) && (w_flag==i1) )
	{
	  w_flag=255;
	  pl[i1].s+=100;

	  // Console message
	  strcpy(s1, pl[i1].name);
	  strcat(s1, " scored (moved flag to the destination).");
	  write_console(s1, pl[i1].pcolor);
	}

	// If player is not in teleport, set pl[i1].tel=0
	if (!( (mapf[ map.m[ (pl[i1].x[0]) ][ pl[i1].y[0] ] ].m>9)
		&& (mapf[ map.m[ (pl[i1].x[0]) ][ pl[i1].y[0] ] ].m<30) ))
	{
	  pl[i1].tel=0;
	}

	// Player reached teleport1
	if ( (mapf[ map.m[ (pl[i1].x[0]) ][ pl[i1].y[0] ] ].m>9)
	  && (mapf[ map.m[ (pl[i1].x[0]) ][ pl[i1].y[0] ] ].m<20)
	  && (pl[i1].tel==0) )
	{
	  search_for_obj(mapf[ map.m[ (pl[i1].x[0]) ][ pl[i1].y[0] ] ].m, &i10, &i11);
	  search_for_obj((mapf[ map.m[ (pl[i1].x[0]) ][ pl[i1].y[0] ] ].m+10), &i12, &i13); //7

	  i14=i12+pl[i1].x[0]-i10;
	  i15=i13+pl[i1].y[0]-i11;
	  pl[i1].x[0]=i14;
	  pl[i1].y[0]=i15;

	  pl[i1].tel=1;

	  // Console message
	  strcpy(s1, pl[i1].name);
	  strcat(s1, " used teleport1.");
	  write_console(s1, pl[i1].pcolor);
	}

	// Player reached teleport2
	if ( (mapf[ map.m[ (pl[i1].x[0]) ][ pl[i1].y[0] ] ].m>19)
	  && (mapf[ map.m[ (pl[i1].x[0]) ][ pl[i1].y[0] ] ].m<30)
	  && (pl[i1].tel==0) )
	{
	  search_for_obj(mapf[ map.m[ (pl[i1].x[0]) ][ pl[i1].y[0] ] ].m, &i10, &i11);
	  search_for_obj((mapf[ map.m[ (pl[i1].x[0]) ][ pl[i1].y[0] ] ].m-10), &i12, &i13);
	  i14=i12+pl[i1].x[0]-i10;
	  i15=i13+pl[i1].y[0]-i11;
	  pl[i1].x[0]=i14;
	  pl[i1].y[0]=i15;

	  pl[i1].tel=1;

	  // Console message
	  strcpy(s1, pl[i1].name);
	  strcat(s1, " used teleport2.");
	  write_console(s1, pl[i1].pcolor);
	}

	// Eating fields
	if ( (mapf[ map.m[ (pl[i1].x[0]) ][ pl[i1].y[0] ] ].m==2)
	  || (mapf[ map.m[ (pl[i1].x[0]) ][ pl[i1].y[0] ] ].m==3) )
	{
	  map.m[ (pl[i1].x[0]) ][ pl[i1].y[0] ]=0;
	}
  }

  // Move rooms
  for (i3=0; i3<4; i3++)
  {
	move_pl=0;
	i4=search_for_obj((i3+30), &i10, &i11);
	if (i4!=(-1))
	{
	  i5=search_for_obj((i3+40), &i12, &i13);

	  i6=search_for_obj((i3+35), &i14, &i15);
	  i7=search_for_obj((i3+45), &i16, &i17);

	  if ( (i5!=(-1)) && (i6!=(-1)) && (i7!=(-1)) )
	  {
		if (i3<2)
		{
		  switch (m_rooms[i3])
		  {
			case 0 : if (i10>(i14+1))
					 {
					   move_room(i10, i11, i12, i13, i14, i15, i16, i17, 0);
					   move_pl=1;
					 }
					 else
					 {
					   m_rooms[i3]=1;
					 }
					 break;
			case 1 : if (i12<(i16-1))
					 {
					   move_room(i10, i11, i12, i13, i14, i15, i16, i17, 1);
					   move_pl=1;
					 }
					 else
					 {
					   m_rooms[i3]=0;
					 }
					 break;
		  } // switch - m_rooms[i3]
		} // if - i3

		if ( (i3>1) && (i3<4) )
		{
		  switch (m_rooms[i3])
		  {
			case 0 : if (i11>(i15+1))
					 {
					   move_room(i10, i11, i12, i13, i14, i15, i16, i17, 2);
					   move_pl=1;
					 }
					 else
					 {
					   m_rooms[i3]=1;
					 }
					 break;
			case 1 : if (i13<(i17-1))
					 {
					   move_room(i10, i11, i12, i13, i14, i15, i16, i17, 3);
					   move_pl=1;
					 }
					 else
					 {
					   m_rooms[i3]=0;
					 }
					 break;
		  } // switch - m_rooms[i3]
		} // if - i3
	  } // if - i5,i6,i7 in range
	} // if - i4 in range

	if (move_pl==1)
	{
	  for (i1=0; i1<n_pl; i1++)
	  {
		for (i2=0; i2<(pl[i1].alen+1); i2++)
		{
		  if ( (pl[i1].x[i2]>(i10-1)) && (pl[i1].y[i2]>(i11-1))
			&& (pl[i1].x[i2]<(i12+1)) && (pl[i1].y[i2]<(i13+1)) )
		  {
			if (i3<2)
			{
			  switch (m_rooms[i3])
			  {
				case 0 : pl[i1].x[i2]--; break;
				case 1 : pl[i1].x[i2]++; break;
			  } // switch - m_rooms[i3]
			} // if - i3

			if ( (i3>1) && (i3<4) )
			{
			  switch (m_rooms[i3])
			  {
				case 0 : pl[i1].y[i2]--; break;
				case 1 : pl[i1].y[i2]++; break;
			  } // switch - m_rooms[i3]
			} // if - i3

		  } // if - pl in range
		} // for - i2
	  } // for - i1
	} // if - move_pl

  } // for - i3

  // Move views
  for (i1=0; i1<n_views; i1++)
  {
	if (views[i1].mv<250)
	{
	  // Move view with player
	  views[i1].xm=pl[ views[i1].mv ].x[0]-(views[i1].xs / 2);
	  views[i1].ym=pl[ views[i1].mv ].y[0]-(views[i1].ys / 2);

	  // If we are on the end, don't move view
	  /*
	  if (views[i1].xm<0) views[i1].xm=0;
	  if (views[i1].ym<0) views[i1].ym=0;
	  if ((views[i1].xm+views[i1].xs)>(n_map_xsize-1)) views[i1].xm=n_map_xsize-views[i1].xs;
	  if ((views[i1].ym+views[i1].ys)>(n_map_ysize-1)) views[i1].ym=n_map_ysize-views[i1].ys;
	  */
	}
  }

  // -- Cheats - begin --
  if (buf_chkcont(chtbuf, CHT_BUF_SIZE, "debug", 1)==1)
  {
	if (n_debug_mode==0) { n_debug_mode=1; }
					else { n_debug_mode=0; }
	buf_addchar(chtbuf, CHT_BUF_SIZE, 32);
  }

  if (buf_chkcont(chtbuf, CHT_BUF_SIZE, "bonusmap1", 1)==1)
  {
	bonus_map1();

	// Console message
	write_console("Entering Bonus MAP1...", 255);

	buf_addchar(chtbuf, CHT_BUF_SIZE, 32);
  }

  if (buf_chkcont(chtbuf, CHT_BUF_SIZE, "iwantflag1", 1)==1)
  {
	w_flag=0;

	// Console message
	strcpy(s1, pl[0].name);
	strcat(s1, " wants the flag, so he's got it :-).");
	write_console(s1, pl[0].pcolor);

	buf_addchar(chtbuf, CHT_BUF_SIZE, 32);
  }

  if (buf_chkcont(chtbuf, CHT_BUF_SIZE, "iwantflag2", 1)==1)
  {
	if (n_pl>1)
	{
	  w_flag=1;

	  // Console message
	  strcpy(s1, pl[1].name);
	  strcat(s1, " wants the flag, so he's got it :-).");
	  write_console(s1, pl[1].pcolor);
	}

	buf_addchar(chtbuf, CHT_BUF_SIZE, 32);
  }

  if (buf_chkcont(chtbuf, CHT_BUF_SIZE, "iwantflag3", 1)==1)
  {
	if (n_pl>2)
	{
	  w_flag=2;

	  // Console message
	  strcpy(s1, pl[2].name);
	  strcat(s1, " wants the flag, so he's got it :-).");
	  write_console(s1, pl[2].pcolor);
	}

	buf_addchar(chtbuf, CHT_BUF_SIZE, 32);
  }

  if (buf_chkcont(chtbuf, CHT_BUF_SIZE, "iwantflag4", 1)==1)
  {
	if (n_pl>3)
	{
	  w_flag=3;

	  // Console message
	  strcpy(s1, pl[3].name);
	  strcat(s1, " wants the flag, so he's got it :-).");
	  write_console(s1, pl[3].pcolor);
	}

	buf_addchar(chtbuf, CHT_BUF_SIZE, 32);
  }
  // -- Cheats - end --
}

void start_game(char play_map_file_name[])
{
  char s1[128];

  load_map(play_map_file_name);
  //init_pl();
  //init_views();
  init_console();

  // -- Console - welcome info --------------------------------
  strcpy(s1, "Build \"");
  strcat(s1, BUILD);
  strcat(s1, "\".");
  write_console(s1, 255);

  write_console("(c)2001-2002 by JC & JK & JM.", 255);

  write_console("For more informations visit http://www.mobilnews.cz/worms/", 255);
  write_console("", 255);
  // ----------------------------------------------------------

  redraw_basic_screen();

  // Initialise game timer (start)
  game_stime=clock();

  // Initialise game timer (actual time and last actual time)
  game_atime=clock();
  game_latime=clock()-(do_move_time / CLK_TCK)-1;

  end_p=0;
  while (end_p==0)
  {
	get_keyb();

	game_atime=clock();
	if ( (game_atime / CLK_TCK) > (((game_latime) / CLK_TCK)+do_move_time) )
	{
	  game_latime=clock();
	  timer2++;

	  do_game();

	  // Division by zero
	  if ( (((game_atime-game_stime) / CLK_TCK) != 0) && (n_debug_mode==1) )
	  {
		gotoxy (1,1);
		printf(" Time: %0.5f  ", ((game_atime-game_stime) / CLK_TCK));
		printf("FPS: %0.2f  Frame:%u  ", (float(timer1) / ((game_atime-game_stime) / CLK_TCK)), timer1);
		printf("MPS: %0.2f (%0.2f%%)  Moves:%u  ", (float(timer2) / ((game_atime-game_stime) / CLK_TCK)), (100.0 / (1.0 / do_move_time))*(float(timer2) / ((game_atime-game_stime) / CLK_TCK)), timer2);
	  }
	}

	redraw_screen();
	if (console_redraw==1) { redraw_console(); }

	timer1++;
  }

  free_map();
  free_views();
}

void conv_mainmenu()
{
  int i1,i2,i3,i4;

  init_pl();

  strcpy(map_file_name, mapfile);

  do_move_time=1.0 / float(speed);
  if (!(do_move_time>0))
	{ do_move_time=0.05; }

  i2=0;
  for (i1=0; i1<MAXPLAYERS; i1++)
  {
	if ( (plrs[i1].exist==1) || (plrs[i1].exist==3) )
	{
	  strcpy(pl[i2].name, plrs[i1].name);
	  pl[i2].pcolor=plrs[i1].color;
	  pl[i2].pchar[0]=240+i1; pl[i2].pchar[1]=244+i1;
	  pl[i2].alen=1; pl[i2].blen=5.0;
	  pl[i2].s=0; // Score
	  pl[i2].d=0; // Direction
	  pl[i2].tel=0; // Teleport

	  for (i3=0; i3<6; i3++)
	  for (i4=0; i4<2; i4++)
	  {
		pl[i2].c[i3][i4]=plrs[i1].key[i3][i4];
	  }

	  // Nokia keys
	  pl[i2].cn=0;
	  if (plrs[i1].exist==3)
	  {
		pl[i2].cn=1;
	  }

	  i2++;
	}
  }

  init_views();
  change_numofpl(i2);
  buf_init(chtbuf, CHT_BUF_SIZE);
}

void main()
{
  char mmenu_ret=1;

  textmode(C4350);
  randomize();

  //show_version_info();

  // -- Main menu ------------------------
  init_players();
  InitPole();
  // -------------------------------------

  while (mmenu_ret==1)
  {
	mmenu_ret=main_menu(1);
	if (mmenu_ret==1)
	{
	  tcolor(7,0);
	  clrscr();
	  conv_mainmenu();
	  start_game(map_file_name);
	  fall1(80,50);
	}
  }

  textmode(C80);
  tcolor(7,0);
  clrscr();

  gotoxy(1,1);
  printf("Build %s.\n", BUILD);
  printf("(c)2001-2002 by JC & JK & JM.\n");
  printf("For more informations visit http://www.mobilnews.cz/worms/\n\n\n");
}
